data locf_yq;
  merge YEAR (in=iny keep=id date)
      QTR (in=inq keep=id date) ;
  by id date;
  /*Read ALL the year variables */
  if iny then set YEAR (rename=(date=YR_DATE));  

  if inq then set QTR ;

  if inq then output;
  /* Don't carry data across ID boundaries*/
  if last.id then call missing(of _all_);  
run;

data locf_yqm ;
  set YEAR  (in=iny keep=id date)
      QTR   (in=inq keep=id date)
      MONTH (in=inm);
  by id date;
  if iny then set YEAR (rename=(date=YR_date));  
  if inq then set QTR  (rename=(date=QTR_date)); 
  if inm then output;
  if last.id then call missing(of _all_); 
run;
