/*Bring YEAR data bask to QTR records.                */
/*Frist create windows start date for each obs in YEAR*/
data YCB / view=YCB ;
  set year;
  by id;

  /* Each window starts one day after prior date */
  _wbeg = sum(lag(date),1);

  /* Begin each ID with arbitrary window start*/
  if first.id then _wbeg='01jan1900'd;  
run;

data nocb_yq (drop=_:) ;  
  /*Fails to reset when future data is expired */
  merge
    YCB (in=iny keep=id _wbeg)
    QTR (in=inq keep=id date rename=(date=_wbeg));
    by id _wbeg;

  if iny then set YCB (rename=(date=yrdate));

  if inq then set QTR  (rename=(date=qtrdate));
  if inq then output;
  if last.id then call missing(of _all_);  
run;


data nocb_yq (drop=_:) ;  
  /* Delete expired future data */
  merge
    YCB (in=iny keep=id _wbeg)
    QTR (in=inq keep=id date rename=(date=_wbeg));
    by id _wbeg;

  if iny then set YCB (rename=(date=yrdate));

  if inq then set QTR  (rename=(date=qtrdate));
  if yrdate < qtrdate then call missing(astA,lbtA);
  if inq then output;
  if last.id then call missing(of _all_);  
run;
