data LOCF_EVT ;
  merge admdis (in=inA keep=id date)
        srvcs  (in=inS keep=id date)
        tests  (in=inT keep=id date);
  by id date;
  if inA then set admdis (rename=(date=date_A));
  if inS then set srvcs  (rename=(date=date_S));
  if inT then set tests  (rename=(date=date_T));
  output;   /* Output a record for every event. No IF test needed*/
  if last.id then call missing (of _all_);
run;
proc compare base=locf_evt compare=sql_locf_evt notes noprint;run;
